package org.implab.gradle.containers;

import java.io.Serializable;
import java.util.Optional;

public class ImageTag implements Serializable {
    
    private static final long serialVersionUID = -1990105923537254552L;

    String authority;

    String qName;

    String version;

    public ImageTag() {
    }

    public ImageTag(ImageTag base) {
        authority = base.authority;
        qName = base.qName;
        version = base.version;
    }

    public String getAuthority() {
        return authority;
    }

    public void setAuthority(String authority) {
        this.authority = authority;
    }

    public ImageTag authority(String authority) {
        this.authority = authority;
        return this;
    }

    public String getQName() {
        return qName;
    }

    public void setQName(String qName) {
        this.qName = qName;
    }

    public ImageTag qName(String qName) {
        this.qName = qName;
        return this;
    }

    public String getVersion() {
        return version;
    }

    public void setVersion(String version) {
        this.version = version;
    }

    public ImageTag version(String version) {
        this.version = version;
        return this;
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();

        Optional.ofNullable(authority).ifPresent(s -> sb.append(s).append("/"));
        Optional.ofNullable(qName).ifPresent(s -> sb.append(s));
        Optional.ofNullable(version).ifPresent(s-> sb.append(":").append(s));

        return sb.toString();
    }
}
